Index: examples/alumni3_rt1_typed/README
===================================================================
--- examples/alumni3_rt1_typed/README	(revision 7727f26afdaff81acebfc2f0d5e4baef296aaf29)
+++ examples/alumni3_rt1_typed/README	(revision 99373511400af88ff4c987810ba7e85b3bbb615c)
@@ -1,4 +1,4 @@
 #!/bin/sh
-
+#
 # This example shows an example of reasoning about a role's parameters.  There
 # are 4 principals StateU, Bob, Mark, Maryann, Joe, and Jan.  StateU wants to
@@ -13,8 +13,8 @@
 # mathematics degree), Mark (a 1965 mathematics degree), Joe (a 1961 zoology degree), Maryann (a 1962 psychology degree), and Jan (a 1960 psychology degree)
 #
-# The attached ./rr file asks if each of these principals are favored alums,
-# and only Bob and Jan are.
+# The attached ./run_query file asks if each of these principals are favored
+# alums, and only Bob and Jan are.
 
-
+# alumni3_rt1_typed
 
 rm -rf *.der *.pem
Index: examples/alumni3_rt1_typed/rr
===================================================================
--- examples/alumni3_rt1_typed/rr	(revision 7727f26afdaff81acebfc2f0d5e4baef296aaf29)
+++ 	(revision )
@@ -1,58 +1,0 @@
-rm -rf creds_dump
-
-pwd=`pwd`
-
-eloc=$pwd/../../libabac
-keyloc=$pwd
-
-stateU=`creddy --keyid --cert $keyloc/StateU_ID.pem`
-
-bob=`creddy --keyid --cert $keyloc/Bob_ID.pem`
-mark=`creddy --keyid --cert $keyloc/Mark_ID.pem`
-joe=`creddy --keyid --cert $keyloc/Joe_ID.pem`
-maryann=`creddy --keyid --cert $keyloc/Maryann_ID.pem`
-jan=`creddy --keyid --cert $keyloc/Jan_ID.pem`
-
-stateU_foundingAlumni="[keyid:$stateU].role:foundingAlumni"
-bob_prin="[keyid:$bob]"
-maryann_prin="[keyid:$maryann]"
-joe_prin="[keyid:$joe]"
-mark_prin="[keyid:$mark]"
-jan_prin="[keyid:$jan]"
-
-# [keyid:stateU].role:foundingAlumni <-?- [keyid:Bob] (yes)
-# [keyid:stateU].role:foundingAlumni <-?- [keyid:Mark] (no)
-# [keyid:stateU].role:foundingAlumni <-?- [keyid:Joe] (no)
-# [keyid:stateU].role:foundingAlumni <-?- [keyid:Maryann] (no)
-# [keyid:stateU].role:foundingAlumni <-?- [keyid:Jan] (yes)
-
-## dump all credentials
-$eloc/abac_prover_yap  --keystore $keyloc --dump creds_dump
-
-# [keyid:stateU].role:foundingAlumni <-?- [keyid:Bob] (yes)
-echo " "
-echo "===good============ stateU.foundingAlumni <- Bob yap "
-$eloc/abac_prover_yap  --keystore $keyloc --role "$stateU_foundingAlumni" --principal "$bob_prin"
-
-# [keyid:stateU].role:foundingAlumni <-?- [keyid:Mark] (no)
-echo " "
-echo "===bad============ stateU.foundingAlumni <- Mark yap "
-$eloc/abac_prover_yap  --keystore $keyloc --role "$stateU_foundingAlumni" --principal "$mark_prin"
-
-# [keyid:stateU].role:foundingAlumni <-?- [keyid:Joe] (no)
-echo " "
-echo "===bad============ stateU.foundingAlumni <- Joe yap "
-$eloc/abac_prover_yap  --keystore $keyloc --role "$stateU_foundingAlumni" --principal "$joe_prin"
-
-# [keyid:stateU].role:foundingAlumni <-?- [keyid:Maryann] (no)
-# asking, isMember(pMaryann,role(pStateU,foundingAlumni),C).
-echo " "
-echo "===bad============ stateU.foundingAlumni <- Maryann yap "
-$eloc/abac_prover_yap  --keystore $keyloc --role "$stateU_foundingAlumni" --principal "$maryann_prin"
-
-# [keyid:stateU].role:foundingAlumni <-?- [keyid:Jan] (yes)
-echo " "
-echo "===good============ stateU.foundingAlumni <- Jan yap "
-$eloc/abac_prover_yap  --keystore $keyloc --role "$stateU_foundingAlumni" --principal "$jan_prin"
-
-
Index: examples/alumni3_rt1_typed/run_query
===================================================================
--- examples/alumni3_rt1_typed/run_query	(revision 99373511400af88ff4c987810ba7e85b3bbb615c)
+++ examples/alumni3_rt1_typed/run_query	(revision 99373511400af88ff4c987810ba7e85b3bbb615c)
@@ -0,0 +1,58 @@
+
+# alumni3_rt1_typed  
+pwd=`pwd`
+
+eloc=$pwd/../../libabac
+keyloc=$pwd
+
+stateU=`creddy --keyid --cert $keyloc/StateU_ID.pem`
+
+bob=`creddy --keyid --cert $keyloc/Bob_ID.pem`
+mark=`creddy --keyid --cert $keyloc/Mark_ID.pem`
+joe=`creddy --keyid --cert $keyloc/Joe_ID.pem`
+maryann=`creddy --keyid --cert $keyloc/Maryann_ID.pem`
+jan=`creddy --keyid --cert $keyloc/Jan_ID.pem`
+
+stateU_foundingAlumni="[keyid:$stateU].role:foundingAlumni"
+bob_prin="[keyid:$bob]"
+maryann_prin="[keyid:$maryann]"
+joe_prin="[keyid:$joe]"
+mark_prin="[keyid:$mark]"
+jan_prin="[keyid:$jan]"
+
+# [keyid:stateU].role:foundingAlumni <-?- [keyid:Bob] (yes)
+# [keyid:stateU].role:foundingAlumni <-?- [keyid:Mark] (no)
+# [keyid:stateU].role:foundingAlumni <-?- [keyid:Joe] (no)
+# [keyid:stateU].role:foundingAlumni <-?- [keyid:Maryann] (no)
+# [keyid:stateU].role:foundingAlumni <-?- [keyid:Jan] (yes)
+
+## dump all credentials
+$eloc/abac_prover_yap  --keystore $keyloc --dump creds_dump
+
+# [keyid:stateU].role:foundingAlumni <-?- [keyid:Bob] (yes)
+echo " "
+echo "===good============ stateU.foundingAlumni <- Bob"
+$eloc/abac_prover_yap  --keystore $keyloc --role "$stateU_foundingAlumni" --principal "$bob_prin"
+
+# [keyid:stateU].role:foundingAlumni <-?- [keyid:Mark] (no)
+echo " "
+echo "===bad============ stateU.foundingAlumni <- Mark"
+$eloc/abac_prover_yap  --keystore $keyloc --role "$stateU_foundingAlumni" --principal "$mark_prin"
+
+# [keyid:stateU].role:foundingAlumni <-?- [keyid:Joe] (no)
+echo " "
+echo "===bad============ stateU.foundingAlumni <- Joe"
+$eloc/abac_prover_yap  --keystore $keyloc --role "$stateU_foundingAlumni" --principal "$joe_prin"
+
+# [keyid:stateU].role:foundingAlumni <-?- [keyid:Maryann] (no)
+# asking, isMember(pMaryann,role(pStateU,foundingAlumni),C).
+echo " "
+echo "===bad============ stateU.foundingAlumni <- Maryann"
+$eloc/abac_prover_yap  --keystore $keyloc --role "$stateU_foundingAlumni" --principal "$maryann_prin"
+
+# [keyid:stateU].role:foundingAlumni <-?- [keyid:Jan] (yes)
+echo " "
+echo "===good============ stateU.foundingAlumni <- Jan"
+$eloc/abac_prover_yap  --keystore $keyloc --role "$stateU_foundingAlumni" --principal "$jan_prin"
+
+